﻿using UnityEngine;

public class CameraShake : MonoBehaviour
{
    private static CameraShake instance;
    // How long the object should shake for.
    public float shakeDuration = 0f;
    // Amplitude of the shake. A larger value shakes the camera harder.
    public float shakeAmountX = 0.7f;
    public float shakeAmountY = 0.7f;
    // How fast the shaking should subside
    public float decreaseFactor = 0.75f;

    float lastCameraYPosition;
    void Start()
    {
        instance = this;
        shakeDuration = 0f;
    }

    void LateUpdate()
    {
        // Shake
        if (shakeDuration > 0)
        {

            shakeDuration -= Time.deltaTime * decreaseFactor;
        }
        else
        {
            shakeDuration = 0f;
        }

        Vector3 direction = Random.insideUnitSphere;
        direction.x *= shakeAmountX + transform.parent.position.x;
        direction.y *= shakeAmountY + transform.parent.position.y;
        // set camera to always match a pixel.
        direction = direction * shakeDuration;
        direction.z = -10f;
        transform.localPosition = direction;
    }

    public static void Shake(float x, float y, float duration)
    {
        instance.ShakeIt(x, y, duration);
    }

    private void ShakeIt(float x, float y, float duration)
    {
        shakeDuration = duration;
        shakeAmountX = x;
        shakeAmountY = y;
        shakeDuration = 0.25f;
    }
}