﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CoffeeMaker : MonoBehaviour
{
    public GameObject coffeePrefab;
    public Animator animator;
    public Transform despensePosition;

    public CoffeeMakerSwitch coffeeMakerSwitch;
    bool hasBean;

    public SpriteRenderer tray;
    public Sprite fullTray;
    public Sprite emptyTray;

    /// <summary>
    /// Update is called every frame, if the MonoBehaviour is enabled.
    /// </summary>
    void Update()
    {
        animator.SetBool("Brew", coffeeMakerSwitch.GetState());
    }

    public void DepositBean()
    {
        hasBean = true;
        animator.SetBool("HasBean", hasBean);
    }

    public void ConsumeBean()
    {
        hasBean = false;
    }

    public bool GetBeanState()
    {
        return hasBean;
    }

    /// <summary>
    /// Sent when another object enters a trigger collider attached to this
    /// object (2D physics only).
    /// </summary>
    /// <param name="other">The other Collider2D involved in this collision.</param>
    void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Bean"))
        {
            hasBean = true;
            tray.sprite = fullTray;
            Destroy(other.gameObject);
        }
    }

    public void DespenceCoffee()
    {
        coffeeMakerSwitch.SwitchOff();
        hasBean = false;
        animator.SetBool("Brew", false);
        animator.SetBool("HasBean", false);
        Instantiate(coffeePrefab, despensePosition.position, new Quaternion(), null);
        tray.sprite = emptyTray;
    }
}
