﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CoffeeMakerSwitch : MonoBehaviour
{
    public struct CoffeeMakerSwitchInfo
    {
        public bool state;
        public CoffeeMakerSwitch switchObject;
    }

    public CoffeeMaker coffeeMaker;

    public AudioClip sfxOn;
    public AudioClip sfxOff;
    public AudioClip sfxCantTurnOn;

    bool isOn;

    AudioSource audioSource;
    void Awake()
    {
        audioSource = GetComponent<AudioSource>();
    }

    public void ToggleSwitch()
    {
        if (!coffeeMaker.GetBeanState() && !isOn)
        {
            audioSource.PlayOneShot(sfxCantTurnOn);
            return;
        }

        isOn = !isOn;
        if (isOn)
        {
            transform.localScale = new Vector3(1, -1, 1);
            audioSource.PlayOneShot(sfxOn);
        }
        else
        {
            transform.localScale = new Vector3(1, 1, 1);
            audioSource.PlayOneShot(sfxOff);
        }
    }

    // returns true id open
    public bool GetState()
    {
        return isOn;
    }

    internal void SwitchOff()
    {
        isOn = false;
        transform.localScale = new Vector3(1, 1, 1);
        audioSource.PlayOneShot(sfxOff);
    }
}
