﻿using UnityEngine;

public class Gate : MonoBehaviour
{
    public struct GateInfo
    {
        public bool state;
        public Gate gateObject;
    }

    public AudioClip sfxOpen;
    public AudioClip sfxClose;
    public SpriteRenderer spriteRenderer;
    public Sprite openSprite;
    public Sprite closeSprite;

    public BoxCollider2D blockingCollider;
    bool open = false;

    AudioSource audioSource;
    /// <summary>
    /// Awake is called when the script instance is being loaded.
    /// </summary>
    void Awake()
    {
        audioSource = GetComponent<AudioSource>();
    }
    public void ToggleGate()
    {
        open = !open;
        if (open)
        {
            spriteRenderer.sprite = openSprite;
            blockingCollider.enabled = false;
            audioSource.PlayOneShot(sfxOpen);
        }
        else
        {
            spriteRenderer.sprite = closeSprite;
            blockingCollider.enabled = true;
            audioSource.PlayOneShot(sfxClose);
        }
    }

    // returns true id open
    public bool GetState()
    {
        return open;
    }
}
