﻿using UnityEngine;
using UnityEngine.InputSystem;
using System.Collections;

public class Move : MonoBehaviour
{
    private Rigidbody2D body;
    public float speed;
    public static InputActions inputAction;

    /// <summary>
    /// Start is called on the frame when a script is enabled just before
    /// any of the Update methods is called the first time.
    /// </summary>
    private void Awake()
    {
        body = GetComponent<Rigidbody2D>();
        inputAction = new InputActions();
        inputAction.PlayerActions.Move.performed += dir => MoveAction(dir.ReadValue<Vector2>());
    }

    Vector2 moveDirection;
    private void MoveAction(Vector2 direction)
    {
        moveDirection = inputAction.PlayerActions.Move.ReadValue<Vector2>();
    }

    private void FixedUpdate()
    {
        if (Player.Dead)
        {
            body.velocity = Vector2.zero;
            return;
        }
        body.velocity = moveDirection * speed * Time.deltaTime;
    }

    void OnEnable()
    {
        inputAction.Enable();
    }

    void OnDisable()
    {
        inputAction.Disable();
    }
}