﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(AudioSource))]
public class WaterWell : MonoBehaviour
{
    public GameObject waterBucketPrefab;
    public Transform spawnPosition;

    private float lastSpawnTime;
    private float spawnInterval = 3f;

    private AudioSource audioSource;

    public AudioClip sfxWater;
    public AudioClip sfxNoWater;
    void Start()
    {
        lastSpawnTime = Time.time - spawnInterval;
        audioSource = GetComponent<AudioSource>();
    }

    // Update is called once per frame
    void Update()
    {

    }

    internal void SpawnWater()
    {
        if (lastSpawnTime + spawnInterval < Time.time)
        {
            audioSource.PlayOneShot(sfxWater);
            Instantiate(waterBucketPrefab, spawnPosition.position, new Quaternion(), null);
            lastSpawnTime = Time.time;
        }
        else
        {
            audioSource.PlayOneShot(sfxNoWater);
        }
    }
}
